import type { Params, Route, Title, TitleGetter, ChangeListener } from './types';
declare class Router {
    params: Params;
    matchedRoute: Route;
    currentTitle: Title;
    _routes: Record<Route, Route>;
    _titleGetters: Record<Route, TitleGetter>;
    _changeListeners: ChangeListener[];
    constructor(routes: Record<Route, Title | TitleGetter>);
    _setParams: (params: Params) => void;
    _setMatchedRoute: (route: Route) => void;
    _setCurrentTitle: (title: Title) => void;
    _removeHash: () => void;
    _syncWithHash: () => void;
    setRoutes: (routes: Record<Route, Title | TitleGetter>) => void;
    navigateTo: (route: Route) => void;
    refresh: () => void;
    _callChangeListeners: () => void;
    addChangeListener: (changeListenerToBeAdded: ChangeListener) => void;
    removeChangeListener: (changeListenerToBeRemoved: ChangeListener) => void;
}
export default Router;
